# Copyright (C) 2009 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# module define
ENABLE_XHAWK  := true
# module end

# module define
ENABLE_IMU_FUSION  := false
# module end

LOCAL_PATH      := $(call my-dir)

PROJ_ROOT_ABS   := ./../../../..
GLM_ROOT_ABS := $(PROJ_ROOT_ABS)/../../3rdParty/glm-master
XDEVICE_JNI     := $(LOCAL_PATH)
XDEVICE_INCLUDE := $(PROJ_ROOT_ABS)/xdevice/include
XDEVICE_SRC     := $(PROJ_ROOT_ABS)/xdevice/src
BLOB_INCLUDE    := $(PROJ_ROOT_ABS)/blob/include
BLOB_SRC        := $(PROJ_ROOT_ABS)/blob/src
BLOB_LIB        := $(PROJ_ROOT_ABS)/blob/lib/android
#LIBUSB_ROOT_ABS := $(PROJ_ROOT_ABS)/../../3rdParty/libusb-master/jni
#HIDAPI_ROOT_ABS := $(PROJ_ROOT_ABS)/../../3rdParty/hidapi-master

include $(CLEAR_VARS)
LOCAL_MODULE    := coordinate
LOCAL_SRC_FILES := $(BLOB_LIB)/$(APP_ABI)/libcoordinate.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE    := interpolation
LOCAL_SRC_FILES := $(BLOB_LIB)/$(APP_ABI)/libinterpolation.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE    := headalignment
LOCAL_SRC_FILES := $(BLOB_LIB)/$(APP_ABI)/libheadalignment.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE    := imuvisualfusion
LOCAL_SRC_FILES := $(BLOB_LIB)/$(APP_ABI)/libimuvisualfusion.a
include $(PREBUILT_STATIC_LIBRARY)


include $(CLEAR_VARS)

LOCAL_C_INCLUDES += \
  $(LIBUSB_ROOT_ABS)/android \
  $(LIBUSB_ROOT_ABS)/libusb \
  $(LIBUSB_ROOT_ABS)/libusb/os \
  $(HIDAPI_ROOT_ABS)/hidapi \
  $(GLM_ROOT_ABS) \
  $(XDEVICE_JNI) \
  $(XDEVICE_INCLUDE) \
  $(BLOB_INCLUDE)

LOCAL_CPPFLAGS += -std=c++11 

LOCAL_MODULE    := xdevice
LOCAL_SRC_FILES := $(LOCAL_PATH)/mutex.cpp \
                   $(XDEVICE_JNI)/string_jni.cpp \
                   $(XDEVICE_SRC)/Mathf.cpp \
                   $(XDEVICE_SRC)/Marshal.cpp \
                   $(XDEVICE_SRC)/Devices.cpp \
                   $(XDEVICE_JNI)/Devices_jni.cpp \
                   $(XDEVICE_SRC)/xdevice.cpp \
                   $(XDEVICE_JNI)/xdevice_jni.cpp \
                   $(XDEVICE_SRC)/DeviceContext.cpp \
                   $(XDEVICE_SRC)/InputDevice.cpp \
                   $(XDEVICE_SRC)/ControllerDevice.cpp \
                   $(XDEVICE_SRC)/ExternalControllerDevice.cpp \
                   $(XDEVICE_SRC)/Daydream.cpp \
                   $(XDEVICE_SRC)/XCobraDevice.cpp \
                   $(XDEVICE_SRC)/Temporary_DeviceContext.cpp
                   
ifeq ($(ENABLE_XHAWK),true)
LOCAL_SRC_FILES += $(XDEVICE_SRC)/TrackerDevice.cpp \
                   $(XDEVICE_SRC)/Boundary.cpp \
                   $(XDEVICE_SRC)/XHawkDevice.cpp \
                   $(XDEVICE_SRC)/MultiChannelStream.cpp
endif

# HIDAPI
# LOCAL_SRC_FILES += $(HIDAPI_ROOT_ABS)/libusb/hid.c \
#                   $(XDEVICE_JNI)/hid_jni.cpp

LOCAL_STATIC_LIBRARIES :=  interpolation headalignment
LOCAL_LDLIBS           := -lm -llog -lz

ifeq ($(ENABLE_XHAWK),true)

LOCAL_SRC_FILES += $(BLOB_SRC)/blob_jni.cpp \
                   $(BLOB_SRC)/blobApi.cpp \
                   $(BLOB_SRC)/Hal_UsbIf.cpp \
                   $(BLOB_SRC)/MsgProcessDrv.cpp \
                   $(BLOB_SRC)/PacketProcessDrv.cpp \
                   $(BLOB_SRC)/XHawkInfo.cpp \
                   $(BLOB_SRC)/position_fifo.cpp \
                   $(BLOB_SRC)/InterpolationModifier.cpp

ifeq  ($(ENABLE_IMU_FUSION),true)
LOCAL_STATIC_LIBRARIES += imuvisualfusion
LOCAL_CPPFLAGS += -DENABLE_IMU_FUSION 
else
LOCAL_STATIC_LIBRARIES += coordinate
endif
endif

#LOCAL_SHARED_LIBRARIES := libusb1.0

include $(BUILD_SHARED_LIBRARY)

#include $(XDEVICE_JNI)/prebuilt/Android.mk