#ifndef __STRING_JNI_H__
#define __STRING_JNI_H__

#include <string.h>
#include <wchar.h>
#include <jni.h>

void memcpy_c2j(JNIEnv* env, jarray jdest, jint joffset, void* src, int size);
void memcpy_j2c(JNIEnv* env, void* dest, jarray jsrc, jint joffset, int size);

void* GetSafeJniBuffer(JNIEnv* env, jarray jsrc, jint joffset, jint jcount, jint mode);
void ReleaseSafeJniBuffer(JNIEnv* env, jarray jsrc, jint joffset, jint jcount, void* buffer, jint mode);

jstring c2js(JNIEnv* env, char* str);
jstring w2js(JNIEnv* env, wchar_t* wstr);

char* js2c(JNIEnv* env, jstring jstr);
wchar_t* js2w(JNIEnv* env, jstring jstr);

#endif
